Ofcas.Lk.Api.Client - Version 3.0 3.0.0.113

Public Member Functions | Protected Member Functions | Properties | List of all members
Ofcas.Lk.Api.Client.Core.CoreObjectWithChildren< TChild, TChildInfo > Class Template Referenceabstract

Realisation of ICoreObjectWithChildren<TChild,TChildInfo>. More...

Inheritance diagram for Ofcas.Lk.Api.Client.Core.CoreObjectWithChildren< TChild, TChildInfo >:

## Public Member Functions
void | DisposeChild (ICoreObject coreObject)
bool | IsParentOf (ICoreObject coreObject)
abstract TChildInfo | RefreshChild (TChildInfo childInfo)
void | RefreshChildren ()
virtual TChild | GetChild (TChildInfo childInfo)
virtual IList< TChild > | GetChildren (IEnumerable< TChildInfo > childrenInfos=null)
virtual OperationInfo | CanCreateChild ()
virtual TChildInfo | CreateChild ()
virtual OperationInfo | CanDeleteChild (TChildInfo childInfo)
virtual void | DeleteChild (TChildInfo childInfo, bool forceDelete=false)
virtual OperationInfo | CanMoveFrom (ICoreInfo coreInfo, bool deepCheck=true)
virtual TChildInfo | MoveFrom (ICoreInfo coreInfo)
virtual OperationInfo | CanCopyFrom (ICoreInfo coreInfo, bool deepCheck=true)
virtual TChildInfo | CopyFrom (ICoreInfo coreInfo)
Public Member Functions inherited from Ofcas.Lk.Api.Client.Core.CoreObjectBase
bool | CanDispose ()
| Returns the information about whether the object can be deleted. An object can only be deleted if no children live. More...
IList< Guid > | Children ()
| Returns a list with Id for all children More...
Public Member Functions inherited from Ofcas.Lk.Api.Client.Core.Disposable
void | Dispose ()

## Protected Member Functions
| CoreObjectWithChildren (IServiceFactory< IApiService > serviceFactory, Guid coreObjectId, bool ownsObject=true)
TChildInfo | RefreshChild (Predicate< TChildInfo > predicate, object childInformation)
| Refreshes all infos and returns the appropriate info. More...
abstract IEnumerable< TChildInfo > | GetChildrenInfos ()
| Gets the children infos. More...
Protected Member Functions inherited from Ofcas.Lk.Api.Client.Core.CoreObjectBase
| CoreObjectBase (IServiceFactory< IApiService > serviceFactory, Guid coreObjectId, bool ownsObject=true)
T | CallService< T > (Func< IApiService, T > serviceCall, Guid projectGuid=default(Guid), [CallerMemberName] string callerMethod=null)
| Calls a service function and raises an error if it fails. More...
T | CallServiceWithMessage< T > (Func< IApiService, T > serviceCall, Guid projectGuid=default(Guid), [CallerMemberName] string callerMethod=null)
| Calls a service function and raises an error if it fails. More...
override void | Dispose (bool disposing)

## Properties
IList< TChildInfo > | ChildrenInfos`[get, protected set]`
Properties inherited from Ofcas.Lk.Api.Client.Core.CoreObjectBase
IServiceFactory< IApiService > | ServiceFactory`[get]`
| For internal purposes only. More...
Guid | Id`[get]`
| The unique identifier of the object instance. More...
Properties inherited from Ofcas.Lk.Api.Client.Core.Interfaces.ICoreObject
Guid | CoreObjectId`[get]`
| This property is deprecated. Please use ICoreObject.Id instead. More...
Guid | Id`[get]`
| The unique identifier of this core object. More...

## Additional Inherited Members
Public Attributes inherited from Ofcas.Lk.Api.Client.Core.CoreObjectBase
Guid | CoreObjectId => Id
| This property is deprecated. Please use CoreObjectBase.Id instead. More...
Protected Attributes inherited from Ofcas.Lk.Api.Client.Core.CoreObjectBase
const string | NotSupportedCauseNotImplemented = "This method is not implemented, therefore not supported."
| Default message for methods which are not supported because they are not implemented. More...
Events inherited from Ofcas.Lk.Api.Client.Core.Disposable
Action< Disposable > | Disposed

## Detailed Description

Realisation of ICoreObjectWithChildren<TChild,TChildInfo>.

Template Parameters

  TChild | The specific type of the child (base ICoreObject).
  TChildInfo | The specific type of the child infos (base ICoreInfo).

Type Constraints

  TChildInfo | : | ICoreInfo |
  TChild | : | ICoreObject |

## Member Function Documentation

## ◆ CopyFrom()

virtual TChildInfo Ofcas.Lk.Api.Client.Core.CoreObjectWithChildren< TChild, TChildInfo >.CopyFrom | ( | ICoreInfo | coreInfo | ) |
| virtual

Exceptions

  NotSupportedException |

## ◆ CreateChild()

virtual TChildInfo Ofcas.Lk.Api.Client.Core.CoreObjectWithChildren< TChild, TChildInfo >.CreateChild | ( |  | ) |
| virtual

Exceptions

  NotSupportedException |

## ◆ DeleteChild()

virtual void Ofcas.Lk.Api.Client.Core.CoreObjectWithChildren< TChild, TChildInfo >.DeleteChild | ( | TChildInfo | childInfo,
|  | bool | forceDelete = `false`
| ) |  |
| virtual

Exceptions

  NotSupportedException |

## ◆ GetChild()

virtual TChild Ofcas.Lk.Api.Client.Core.CoreObjectWithChildren< TChild, TChildInfo >.GetChild | ( | TChildInfo | childInfo | ) |
| virtual

Exceptions

  NotSupportedException |

## ◆ GetChildren()

virtual IList<TChild> Ofcas.Lk.Api.Client.Core.CoreObjectWithChildren< TChild, TChildInfo >.GetChildren | ( | IEnumerable< TChildInfo > | childrenInfos = `null` | ) |
| virtual

Exceptions

  NotSupportedException |

## ◆ GetChildrenInfos()

abstract IEnumerable<TChildInfo> Ofcas.Lk.Api.Client.Core.CoreObjectWithChildren< TChild, TChildInfo >.GetChildrenInfos | ( |  | ) |
| protected pure virtual

Gets the children infos.

Returns
  Returns the children infos.

Implemented in Ofcas.Lk.Api.Client.Core.LoginScope, Ofcas.Lk.Api.Client.Core.DocumentContainer, Ofcas.Lk.Api.Client.Core.ElementPricelistContainer, and Ofcas.Lk.Api.Client.Core.ProjectInformationContainer.

## ◆ MoveFrom()

virtual TChildInfo Ofcas.Lk.Api.Client.Core.CoreObjectWithChildren< TChild, TChildInfo >.MoveFrom | ( | ICoreInfo | coreInfo | ) |
| virtual

Exceptions

  NotSupportedException |

## ◆ RefreshChild()

TChildInfo Ofcas.Lk.Api.Client.Core.CoreObjectWithChildren< TChild, TChildInfo >.RefreshChild | ( | Predicate< TChildInfo > | predicate,
|  | object | childInformation
| ) |  |
| protected

Refreshes all infos and returns the appropriate info.

Parameters

  predicate | The predicate for the given info.
  childInformation | Additional information identifying the child in case of error.

Returns
  Returns the refreshed info object.

Exceptions

  ApiException | if the child was not include in the list

The documentation for this class was generated from the following file:

- CoreObjectWithChildren.cs